/*
 * Copyright (c) 2004-2012 CNRS/LAAS
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS.
 */

#ifndef _GYRO_LIB_H
#define _GYRO_LIB_H

#ifdef __cplusplus
extern "C" {
#endif

/* Error Codes */
#define M_gyroLib                      692
#define S_gyroLib_SEND_CMD_ERROR       ((M_gyroLib << 16) | 1)
#define S_gyroLib_ALREADY_INITIALIZED  ((M_gyroLib << 16) | 2)
#define S_gyroLib_NOT_INITIALIZED      ((M_gyroLib << 16) | 3)
#define S_gyroLib_DATA_NOT_VALID       ((M_gyroLib << 16) | 4)

struct GYRO_DATA *gyroInitKVH1000(const char *port, double, double);
struct GYRO_DATA *gyroInitKVH5000(const char *port, double, double);
struct GYRO_DATA *gyroInit(int type, const char *port, double, double);
BOOL gyroEnd(struct GYRO_DATA *);
BOOL gyroReadAngle(struct GYRO_DATA *, double *theta);
BOOL gyroReadW(struct GYRO_DATA *, double *);
BOOL gyroRead(struct GYRO_DATA *, double *, double *, uint32_t *);
BOOL gyroUpdateWOffset(struct GYRO_DATA *, int);
double gyroReadWOffset(struct GYRO_DATA *);
BOOL gyroResetAngle(struct GYRO_DATA *, double theta);

#ifdef __cplusplus
}
#endif

#endif	/* _GYRO_LIB_H */
